/*
* $Header: InitializeI.h,v 1.24 88/09/22 14:54:57 asente Exp $
*/
/*
*****************************************************************************
**                                                                          *
**                         COPYRIGHT (c) 1988 BY                            *
**             DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS.                *
**	MASSACHUSSETTS INSTITUTE OF TECHNOLOGY, CAMBRIDGE, MASS.	    *
**                         ALL RIGHTS RESERVED                              *
**                                                                          *
**  THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND  COPIED  *
**  ONLY  IN  ACCORDANCE  WITH  THE  TERMS  OF  SUCH  LICENSE AND WITH THE  *
**  INCLUSION OF THE ABOVE COPYRIGHT NOTICE.  THIS SOFTWARE OR  ANY  OTHER  *
**  COPIES  THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY  *
**  OTHER PERSON.  NO TITLE TO AND OWNERSHIP OF  THE  SOFTWARE  IS  HEREBY  *
**  TRANSFERRED.                                                            *
**                                                                          *
**  THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE  WITHOUT  NOTICE  *
**  AND  SHOULD  NOT  BE  CONSTRUED  AS  A COMMITMENT BY DIGITAL EQUIPMENT  *
**  CORPORATION OR MIT.                                                     *
**                                                                          *
**  DIGITAL ASSUMES NO RESPONSIBILITY FOR THE USE OR  RELIABILITY  OF  ITS  *
**  SOFTWARE ON EQUIPMENT WHICH IS NOT SUPPLIED BY DIGITAL.                 *
**                                                                          *
*****************************************************************************
**++
**  FACILITY:
**
**      < to be supplied >
**
**  ABSTRACT:
**
**      < to be supplied >
**
**  ENVIRONMENT:
**
**      < to be supplied >
**
**  MODIFICATION HISTORY:
**
**      < to be supplied >
**
**--
**/

#ifndef _InitializeI_h_
#define _InitializeI_h_

/****************************************************************
 *
 * Displays
 *
 ****************************************************************/

#ifndef VMS
#include <sys/time.h>
#else
#include <types.h>
#include <time.h>
#endif /* VMS */
#ifndef VMS
#include <sys/file.h>
#include <sys/time.h>
#include <sys/param.h>
#else
#include file
#include <types.h>
#include <time.h>
#endif /* VMS */


typedef struct _TimerEventRec {
#ifdef VMS
        vms_time te_timer_value;
#else
        struct timeval   te_timer_value;
#endif /* VMS */
	struct _TimerEventRec *te_next;
	Display *te_dpy;
	XtTimerCallbackProc	te_proc;
	XtAppContext app;
	Opaque	te_closure;
} TimerEventRec;

typedef struct _iosb {                  /* Generic IO Status Block for VMS */
        short int cond_val;             /* condition code value. Low bit set indicates success */
        short int trans_count;          /* count of data transfered (notused) */
        int       dev_spec_info;        /* device specific info (not used) */
} iosb;                                 /* Note that not all IOSBs have this */
                                        /* exact format */



typedef struct _InputEvent {
	XtInputCallbackProc  ie_proc;
	Opaque ie_closure;
	struct	_InputEvent	*ie_next;
	struct  _InputEvent	*ie_oq;
	XtAppContext app;
	int	ie_source;
	iosb	*ie_iosb;
} InputEvent;

typedef struct _WorkProcRec {
	XtWorkProc proc;
	Opaque closure;
	struct _WorkProcRec *next;
	XtAppContext app;
} WorkProcRec;


typedef struct 
{
  	Fd_set rmask;
	Fd_set wmask;
	Fd_set emask;
	int	nfds;
	int	count;
} FdStruct;

#ifdef VMS
#define NOFILE	32
#endif /* VMS */

typedef struct _XtAppStruct {
    Display **list;
    TimerEventRec *timerQueue;
    WorkProcRec *workQueue;
    InputEvent *selectRqueue[NOFILE], *selectWqueue[NOFILE],
	    *selectEqueue[NOFILE];
    InputEvent *outstandingQueue;
#ifdef VMS
    unsigned long Input_EF_Mask;
#endif /* VMS */
#ifdef R3_INTRINSICS
    XrmDatabase errorDB;
    XtErrorMsgHandler errorMsgHandler, warningMsgHandler;
    XtErrorHandler errorHandler, warningHandler;
    struct _ActionListRec *action_table;
    ConverterTable converterTable;
    unsigned long selectionTimeout;
    /* ||| Delete next line if backwards compat stuff ever removed */
    Boolean use_error, use_actions, use_conversions, use_selection;
#endif /* R3_INTRINSICS */
    FdStruct fds;
    short count, max, last;
#ifdef R3_INTRINSICS
    Boolean sync, rv, being_destroyed, error_inited;
#else
    Boolean sync, rv, being_destroyed;
#endif /* R3_INTRINSICS */
} XtAppStruct;

#ifdef R3_INTRINSICS
extern void _XtSetDefaultErrorHandlers();
extern void _XtSetDefaultSelectionTimeout();
extern void _XtSetDefaultConverterTable();
extern void _XtFreeConverterTable();
#endif /* R3_INTRINSICS */

extern XtAppContext _XtDefaultAppContext();
extern void _XtDestroyAppContexts();
extern void _XtCloseDisplays();
/* extern int _XtAppDestroyCount;
extern int _XtDpyDestroyCount; */

extern int _XtwaitForSomething(); /* ignoreTimers, ignoreInputs, block, 
					howlong, dset */
    /* Boolean ignoreTimers; */
    /* Boolean ignoreInputs; */
    /* Boolean block; */
    /* unsigned long *howlong; */
    /* XtAppContext app */

typedef struct _XtPerDisplayStruct {
    Region region;
    XtCaseProc defaultCaseConverter;
    XtKeyProc defaultKeycodeTranslator;
    XtAppContext appContext;
    KeySym *keysyms;                   /* keycode to keysym table */
    int keysyms_per_keycode;           /* number of keysyms for each keycode */
    KeySym *modKeysyms;                /* keysym values for modToKeysysm */
    ModToKeysymTable *modsToKeysyms;   /* modifiers to Keysysms index table*/
    Boolean being_destroyed;
    XrmName name;		       /* resolved app name */
    XrmClass class;		       /* R2 compatibility only */
    String languageSpec;
} XtPerDisplayStruct, *XtPerDisplay;

extern void _XtPerDisplayInitialize();

extern XtPerDisplay _XtGetPerDisplay();
    /* Display *dpy */

#ifdef R3_INTRINSICS
extern XtAppContext _XtDisplayToApplicationContext();
    /* Display *dpy */
#endif /* R3_INTRINSICS */
	
extern void _XtDisplayInitialize();
    /* 	Display *dpy; */
    /* 	String name, classname; */
    /* 	XrmOptionDescRec *urlist */;
    /* 	Cardinal num_urs; */
    /* 	Cardinal *argc; */
    /* 	char *argv[];  */

#endif /* _InitializeI_h_ */
